from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Int, Float, File

Seqkit_Seq_V0_1_0 = CommandToolBuilder(tool="seqkit_seq", base_command=["seqkit", "seq"], inputs=[ToolInput(tag="in_color", input_type=Boolean(optional=True), prefix="--color", doc=InputDocumentation(doc="colorize sequences - to be piped into 'less -R'")), ToolInput(tag="in_complement", input_type=Boolean(optional=True), prefix="--complement", doc=InputDocumentation(doc="complement sequence, flag '-v' is recommended to switch on")), ToolInput(tag="in_dna_two_rna", input_type=Boolean(optional=True), prefix="--dna2rna", doc=InputDocumentation(doc="DNA to RNA")), ToolInput(tag="in_gap_letters", input_type=String(optional=True), prefix="--gap-letters", doc=InputDocumentation(doc="gap letters (default '- \t.')")), ToolInput(tag="in_lower_case", input_type=Boolean(optional=True), prefix="--lower-case", doc=InputDocumentation(doc="print sequences in lower case")), ToolInput(tag="in_max_len", input_type=Int(optional=True), prefix="--max-len", doc=InputDocumentation(doc="only print sequences shorter than the maximum length (-1 for no limit) (default -1)")), ToolInput(tag="in_max_qual", input_type=Float(optional=True), prefix="--max-qual", doc=InputDocumentation(doc="only print sequences with average quality less than this limit (-1 for no limit) (default -1)")), ToolInput(tag="in_min_len", input_type=Int(optional=True), prefix="--min-len", doc=InputDocumentation(doc="only print sequences longer than the minimum length (-1 for no limit) (default -1)")), ToolInput(tag="in_min_qual", input_type=Float(optional=True), prefix="--min-qual", doc=InputDocumentation(doc="only print sequences with average quality qreater or equal than this limit (-1 for no limit) (default -1)")), ToolInput(tag="in_name", input_type=Boolean(optional=True), prefix="--name", doc=InputDocumentation(doc="only print names")), ToolInput(tag="in_only_id", input_type=Boolean(optional=True), prefix="--only-id", doc=InputDocumentation(doc="print ID instead of full head")), ToolInput(tag="in_qual", input_type=Boolean(optional=True), prefix="--qual", doc=InputDocumentation(doc="only print qualities")), ToolInput(tag="in_qual_ascii_base", input_type=Int(optional=True), prefix="--qual-ascii-base", doc=InputDocumentation(doc="ASCII BASE, 33 for Phred+33 (default 33)")), ToolInput(tag="in_remove_gaps", input_type=Boolean(optional=True), prefix="--remove-gaps", doc=InputDocumentation(doc="remove gaps")), ToolInput(tag="in_reverse", input_type=Boolean(optional=True), prefix="--reverse", doc=InputDocumentation(doc="reverse sequence")), ToolInput(tag="in_rna_two_dna", input_type=Boolean(optional=True), prefix="--rna2dna", doc=InputDocumentation(doc="RNA to DNA")), ToolInput(tag="in_seq", input_type=Boolean(optional=True), prefix="--seq", doc=InputDocumentation(doc="only print sequences")), ToolInput(tag="in_upper_case", input_type=Boolean(optional=True), prefix="--upper-case", doc=InputDocumentation(doc="print sequences in upper case")), ToolInput(tag="in_validate_seq", input_type=Boolean(optional=True), prefix="--validate-seq", doc=InputDocumentation(doc="validate bases according to the alphabet")), ToolInput(tag="in_validate_seq_length", input_type=Int(optional=True), prefix="--validate-seq-length", doc=InputDocumentation(doc="length of sequence to validate (0 for whole seq) (default 10000)")), ToolInput(tag="in_alphabet_guess_seq_length", input_type=Int(optional=True), prefix="--alphabet-guess-seq-length", doc=InputDocumentation(doc="length of sequence prefix of the first FASTA record based on which seqkit guesses the sequence type (0 for whole seq) (default 10000)")), ToolInput(tag="in_id_ncbi", input_type=Boolean(optional=True), prefix="--id-ncbi", doc=InputDocumentation(doc="FASTA head is NCBI-style, e.g. >gi|110645304|ref|NC_002516.2| Pseud...")), ToolInput(tag="in_id_regexp", input_type=String(optional=True), prefix="--id-regexp", doc=InputDocumentation(doc="regular expression for parsing ID (default '^(\\S+)\\s?')")), ToolInput(tag="in_in_file_list", input_type=File(optional=True), prefix="--infile-list", doc=InputDocumentation(doc="file of input files list (one file per line), if given, they are appended to files from cli arguments")), ToolInput(tag="in_line_width", input_type=Int(optional=True), prefix="--line-width", doc=InputDocumentation(doc="line width when outputing FASTA format (0 for no wrap) (default 60)")), ToolInput(tag="in_out_file", input_type=File(optional=True), prefix="--out-file", doc=InputDocumentation(doc="out file ('-' for stdout, suffix .gz for gzipped out) (default '-')")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="be quiet and do not show extra information")), ToolInput(tag="in_seq_type", input_type=String(optional=True), prefix="--seq-type", doc=InputDocumentation(doc="sequence type (dna|rna|protein|unlimit|auto) (for auto, it automatically detect by the first sequence) (default 'auto')")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="number of CPUs. (default value: 1 for single-CPU PC, 2 for others. can also set with environment variable SEQKIT_THREADS) (default 2)"))], outputs=[ToolOutput(tag="out_out_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_file", type_hint=File()), doc=OutputDocumentation(doc="out file ('-' for stdout, suffix .gz for gzipped out) (default '-')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Seqkit_Seq_V0_1_0().translate("wdl", allow_empty_container=True)

